#include "../../global.h"

InvadersVideo::InvadersVideo(Machine *hw, ScreenOutput *disp, uint8 *cr) : InvadersVideoHardware(hw, disp, cr) {

    // Nothing
}

void InvadersVideo::writeVideoRAM(uint16 addr, uint8 data) {

    // We render the screen as we go, since it's bitmapped

    int i,x,y;

    x = addr / 32;
    y = 240 - 8 * (addr % 32);

    // Can't assume clipping will be done for pixel plotting

    if (y<0 || y>239) return;

    for (i=0; i<8; i++) {

        int col=1;

        // NOTE: correct these!
        if (y >= 184-8 && y < 240-8) col = 2;
        if (y >= 240-8 && x > 16 && x < 134) col = 2;
        if (y >= 32-8 && y < 64-8) col = 3;

        if (data & 0x80) {

            display->setScreenPixel(x, y, col);
        }
        else {

            display->setScreenPixel(x, y, col+3);
        }

        y++;
        data <<= 1;
    }
}

void InvadersVideo::setupDisplay(void) {

    display->setMode(224, 240, 60);

    display->setPalette(0, 0x000000);

    display->setPalette(1, 0xdddddd);
    display->setPalette(2, 0x33dd33);
    display->setPalette(3, 0xdd3333);

    display->setPalette(4, 0x101010);
    display->setPalette(5, 0x002500);
    display->setPalette(6, 0x250000);

    // This ensures that the bars are drawn

    for (int i=0; i<0x1bff; i++) {

        writeVideoRAM(i, 0);
    }
}
