#include "../../global.h"

PleiadsVideo::PleiadsVideo(Machine *hw, ScreenOutput *disp, uint8 *cr) : PhoenixVideoHardware(hw, disp, cr) {

}

void PleiadsVideo::setupDisplay(void) {

    display->setMode(26*8, 32*8, 60);

    display->setPalette(black, 0x000000);
    display->setPalette(white, 0xffffff);
    display->setPalette(red, 0xff0000);
    display->setPalette(green, 0x00ff00);
    display->setPalette(blue, 0x2424db);
    display->setPalette(cyan, 0x00db95);
    display->setPalette(yellow, 0xffff00);
    display->setPalette(pink, 0xffb6db);
    display->setPalette(orange, 0xffb649);
    display->setPalette(lpurple, 0xff24b6);
    display->setPalette(dorange, 0xffb600);
    display->setPalette(dpurple, 0xb624ff);
    display->setPalette(grey, 0x959595);
    display->setPalette(dyellow, 0xdbdb00);
    display->setPalette(blueish, 0x0095ff);
    display->setPalette(purple, 0xff00ff);
}

uint8 PleiadsVideo::lookupColour(uint16 sprite, uint8 colour, uint16 bank, uint16 palette) {

    // These are wrong, so I need screen shots to fix them.  If
    // I had the PROMs, I probably wouldn't need a separate Pleiads
    // video class.

    const uint8 charColours[] = {

        black, cyan,   black,   cyan,
        black, red,    yellow,  white,
        black, red,    yellow,  white,
        black, purple, pink,    yellow,
        black, purple, pink,    yellow,
        black, purple, pink,    yellow,
        black, purple, white ,  yellow,
        black, green,  purple,  white,

        black, cyan,   blue,    cyan,
        black, red,    yellow,  white,
        black, red,    yellow,  white,
        black, green,  yellow,  purple,
        black, green,  yellow,  purple,
        black, green,  yellow,  purple,
        black, red,    white,   purple,
        black, green,  purple,  white,

        black, blue,   red,     grey,
        black, blueish,purple,  dorange,
        black, green,  dpurple, dorange,
        black, dpurple,blueish, lpurple,
        black, blueish,purple,  green,
        black, blueish,purple,  green,
        black, blueish,purple,  green,
        black, blueish,purple,  green,

        black, blue,   red,     grey,
        black, blueish,purple,  dorange,
        black, green,  dpurple, dorange,
        black, dpurple,blueish, lpurple,
        black, lpurple,blueish, green,
        black, lpurple,blueish, green,
        black, lpurple,blueish, green,
        black, lpurple,blueish, green,
    };

    return charColours[colour+(32*((2*bank)+palette))+((sprite/32)*4)];
}
