class AudioOutput {

    public:

    AudioOutput();
    ~AudioOutput();

    void *loadSample(char *);
    void *createSynth(int8 *, const uint32, const uint32);

    void freeSample(void *);
    void freeSynth(void *);

    void *openChannel(const uint8, const uint8);
    void closeChannel(void *);
    bool channelActive(void *);

    inline void stopChannel(void *channel) {

    	AStopVoice(*(LPHAC)channel);
    }

    inline void playWaveform(void *wave, void *channel) {

		if (APlayVoice(*((LPHAC)channel), (LPAUDIOWAVE)wave)) {

			cerr << "Unable to play waveform.\n";
    	    exit(1);
	   	}
	}


    inline void modifySynth(void *wave, int8 *data) {

		memcpy(((LPAUDIOWAVE)wave)->lpData, data, ((LPAUDIOWAVE)wave)->dwLength);
    	AWriteAudioData((LPAUDIOWAVE)wave, 0L, ((LPAUDIOWAVE)wave)->dwLength);
	}

	inline void update(void) {

		AUpdateAudio();
	}

};
