#include "../global.h"

Mouse::Mouse() {

    Epp::log("Installing mouse handler.");

	install_mouse();
    position_mouse(63, 63);
    xoffset=yoffset=0;
}

void Mouse::update() {

    static int8 prevx=0, prevy=0;

    if(mouse_x-63) {

        prevx=xoffset;
    	xoffset=mouse_x-63;
    	if(xoffset > 63) xoffset=63;
    	if(xoffset < -63) xoffset=-63;
    }
    else {

    	xoffset=prevx;
    	prevx=mouse_x-63;
   		if(prevx > 63) prevx=63;
   		if(prevx < -63) prevx=-63;
    }

    if(mouse_y-63) {

        prevy=yoffset;
    	yoffset=mouse_y-63;
   		if(yoffset > 63) yoffset=63;
   		if(yoffset < -63) yoffset=-63;
    }
    else {

    	yoffset=prevy;
    	prevy=mouse_y-63;
   		if(prevy > 63) prevy=63;
   		if(prevy < -63) prevy=-63;
    }

    position_mouse(63, 63);

    b1=mouse_b & 0x01;
    b2=mouse_b & 0x02;
}

int8 Mouse::getXAxis(void) {

   	return (int8)xoffset;
}

int8 Mouse::getYAxis(void) {

   	return (int8)yoffset;
}

bool Mouse::button1(void) {

 	return b1;
}

bool Mouse::button2(void) {

 	return b2;
}
