class InvadersHardware : public Machine {

    public:

    InvadersHardware(Epp *, ScreenOutput *, AudioOutput *, Keyboard *, Joystick *);

    uint8 readMem(const Component *, const uint16);
    void writeMem(const Component *, const uint16, const uint8);
    void out(const Component *, const uint16, const uint8);
    uint8 in(const Component *, const uint16);
    void emulate(void);
    void reset(void);

    protected:

    virtual void readROMs(void) = 0;
    virtual void createComponents(void) = 0;
    void destroyComponents(void);

    uint8 bitshift();

    uint8 memory[0x10000];

    Joystick *joystick;
    Keyboard *keyboard;

    Z80 *cpu;
    InvadersVideoHardware *vid;

    uint8 bsamount, bsdata1, bsdata2;
    void *channel[6];
    void *sample[9];
    uint8 playing1, playing2;
    uint8 dip1;
};

