#include "../global.h"

LunarRescue::LunarRescue(Epp *e, ScreenOutput *disp, AudioOutput *au, Keyboard *kb, Joystick *js) : InvadersHardware(e, disp, au, kb, js) {

}

void LunarRescue::readROMs(void) {

    readROM("roms/lrescue.1", memory+0x0000, 0x0800);
    readROM("roms/lrescue.2", memory+0x0800, 0x0800);
    readROM("roms/lrescue.3", memory+0x1000, 0x0800);
    readROM("roms/lrescue.4", memory+0x1800, 0x0800);
    readROM("roms/lrescue.5", memory+0x4000, 0x0800);
    readROM("roms/lrescue.6", memory+0x4800, 0x0800);

    sample[0]=audio->loadSample("samples/invaders.0");
    sample[1]=audio->loadSample("samples/invaders.1");
    sample[2]=audio->loadSample("samples/invaders.2");
    sample[3]=audio->loadSample("samples/invaders.3");
    sample[4]=audio->loadSample("samples/invaders.4");
    sample[5]=audio->loadSample("samples/invaders.5");
    sample[6]=audio->loadSample("samples/invaders.6");
    sample[7]=audio->loadSample("samples/invaders.7");
    sample[8]=audio->loadSample("samples/invaders.8");

    dip1=epp->getSetting("lrescue", 0);
    dip1|=epp->getSetting("lrescue", 1)<<3;
}

void LunarRescue::createComponents(void) {

    cpu = new Z80(this);
    vid = new LunarRescueVideo(this, display, NULL);
}