#include "../global.h"

Pleiads::Pleiads(Epp *e, ScreenOutput *disp, AudioOutput *au, Keyboard *kb, Joystick *js) : PhoenixHardware(e, disp, au, kb, js) {

}

void Pleiads::readROMs(void) {

    readROM("roms/pleiades.47", memory+0x0000, 0x0800);
    readROM("roms/pleiades.48", memory+0x0800, 0x0800);
    readROM("roms/pleiades.49", memory+0x1000, 0x0800);
    readROM("roms/pleiades.50", memory+0x1800, 0x0800);
    readROM("roms/pleiades.51", memory+0x2000, 0x0800);
    readROM("roms/pleiades.52", memory+0x2800, 0x0800);
    readROM("roms/pleiades.53", memory+0x3000, 0x0800);
    readROM("roms/pleiades.54", memory+0x3800, 0x0800);

    readROM("roms/pleiades.27", charROM+0x0000, 0x0800);
    readROM("roms/pleiades.26", charROM+0x0800, 0x0800);
    readROM("roms/pleiades.45", charROM+0x1000, 0x0800);
    readROM("roms/pleiades.44", charROM+0x1800, 0x0800);

    dip1=0x40;
    dip1|=epp->getSetting("pleiads", 0);
    dip1|=epp->getSetting("pleiads", 1)<<2;
}

void Pleiads::createComponents(void) {

    cpu = new Z80(this);
    vid = new PleiadsVideo(this, display, charROM);
}